=== debian/changelog ===
radare2-cutter (1.7.4-2+rb2) UNRELEASED; urgency=medium

  * update

 -- Debian Security Tools <team+pkg-security@tracker.debian.org>  Fri, 22 Jan 2021 12:17:43 +0800

radare2-cutter (1.7.4-2) unstable; urgency=medium

  * Fix installation from build directory, fixing FTBFS on i386

 -- Hilko Bengen <bengen@debian.org>  Mon, 04 Feb 2019 12:01:29 +0100

radare2-cutter (1.7.4-1) unstable; urgency=low

  * Team upload
  * Initial release. (Closes: #910850)

 -- Hilko Bengen <bengen@debian.org>  Sat, 26 Jan 2019 00:54:03 +0100
