=== debian/control ===
Source: radare2-cutter
Section: devel
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Sebastian Reichel <sre@debian.org>
Build-Depends: cmake,
               debhelper (>= 12),
               pkg-config,
               python3-dev,
               qtbase5-dev,
               qtwebengine5-dev,
               libzip-dev,
               libqt5svg5-dev,
               libcapstone-dev,
               libradare2-dev,
               zlib1g-dev,
               libxxhash-dev,
Standards-Version: 4.3.0
Homepage: https://www.radare.org
Vcs-Browser: https://salsa.debian.org/pkg-security-team/radare2-cutter
Vcs-Git: https://salsa.debian.org/pkg-security-team/radare2-cutter.git

Package: radare2-cutter
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         python3,
         python3-jupyter-client,
         python3-notebook,
         python3-ipykernel,
         python3-zmq,
Description: GUI for radare2 reverse engineering framework
 Cutter is a Qt based GUI for reverse engineering binaries, which makes
 use of the radare2 framework. Advanced users are expected to use the
 radare2 CLI tools instead, which are much more powerful.
