=== debian/rules ===
#!/usr/bin/make -f
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --buildsystem=cmake --sourcedirectory=src

override_dh_auto_configure:
	dh_auto_configure -- -DCUTTER_ENABLE_QTWEBENGINE=1

override_dh_auto_install:
	mkdir -p debian/radare2-cutter/usr/bin
	install -m755 ./obj-$(DEB_HOST_GNU_TYPE)/Cutter debian/radare2-cutter/usr/bin/
	mkdir -p debian/radare2-cutter/usr/share/applications
	install -m644 ./src/org.radare.Cutter.desktop debian/radare2-cutter/usr/share/applications
	mkdir -p debian/radare2-cutter/usr/share/icons/hicolor/scalable/apps
	install -m644 ./src/img/cutter.svg debian/radare2-cutter/usr/share/icons/hicolor/scalable/apps
