=== src/meson_options.txt ===
option('enable_python', type: 'boolean', value: true)
option('enable_python_bindings', type: 'boolean', value: true)
