=== debian/changelog ===
radare2-cutter (1.10.1-3) unstable; urgency=medium

  * d/control: make supported architectures explicit
  * d/rules: set MAKE_BUILD_TYPE to remove debug fuzz
  * d/rules: export harding flags like suggested in the docs
  * d/rules: make crash reports opt-in (privacy)

 -- Robert Haist <rha@debian.org>  Thu, 27 Feb 2020 14:20:23 +0100

radare2-cutter (1.10.1-2) unstable; urgency=medium

  * d/control: Add dh-strip-nondeterminism to build reproducible
  * d/control: Point to the correct Cutter website (Closes: #921391)
  * This release and libradare2 in sid closes: #931172

 -- Robert Haist <rha@debian.org>  Wed, 26 Feb 2020 12:51:37 +0100

radare2-cutter (1.10.1-1) unstable; urgency=medium

  [ Hilko Bengen ]
  * New upstream version 1.8.0
  * New upstream version 1.8.1

  [ Samuel Henrique ]
  * Add salsa-ci.yml
  * Configure git-buildpackage for Debian

  [ Robert Haist ]
  * New upstream version 1.10.1
  * Added python support
  * Added syntax highlighting support
  * Added graphviz support
  * Bump standards version
  * Move to debhelper-compat

 -- Robert Haist <rha@debian.org>  Tue, 18 Feb 2020 23:02:09 +0100
