=== debian/control ===
Source: radare2-cutter
Section: devel
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Sebastian Reichel <sre@debian.org>, Robert Haist <rha@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 12),
               dh-strip-nondeterminism,
               libcapstone-dev,
               libgraphviz-dev,
               libkf5syntaxhighlighting-dev,
               libqt5svg5-dev,
               libradare2-dev,
               libxxhash-dev,
               libzip-dev,
               pkg-config,
               python3-dev,
               qtbase5-dev,
               qtwebengine5-dev,
               zlib1g-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://cutter.re
Vcs-Browser: https://salsa.debian.org/pkg-security-team/radare2-cutter
Vcs-Git: https://salsa.debian.org/pkg-security-team/radare2-cutter.git

Package: radare2-cutter
Architecture: amd64 arm64 armhf i386 mipsel
Depends: python3,
         python3-ipykernel,
         python3-jupyter-client,
         python3-notebook,
         python3-zmq,
         ${misc:Depends},
         ${shlibs:Depends}
Description: GUI for radare2 reverse engineering framework
 Cutter is a Qt based GUI for reverse engineering binaries, which makes
 use of the radare2 framework. Advanced users are expected to use the
 radare2 CLI tools instead, which are much more powerful.
