=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
 
-DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 
@@ -10,7 +10,10 @@
 	dh $@ --buildsystem=cmake --sourcedirectory=src
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCUTTER_ENABLE_QTWEBENGINE=1
+	dh_auto_configure -- \
+		-DCUTTER_ENABLE_PYTHON=ON \
+		-DCUTTER_ENABLE_CRASH_REPORTS=OFF \
+		-DCMAKE_BUILD_TYPE=Release
 
 override_dh_auto_install:
 	mkdir -p debian/radare2-cutter/usr/bin
