=== debian/watch ===
version=3
opts=\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/cutter-$1\.tar\.gz/\
 https://github.com/radareorg/cutter/tags .*/v?(\d\S+)\.tar\.gz
