## radare2-cutter 1.10.2

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -44,7 +44,7 @@
 
 set(CMAKE_CXX_STANDARD 11)
 
-include_directories(core widgets common plugins)
+include_directories(core widgets common plugins menus)
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 set(CMAKE_AUTOMOC ON)
