=== debian/changelog ===
radare2-cutter (1.12.0-2) unstable; urgency=medium

  [ Arnaud Rebillout ]
  * Team upload
  * Add patches to build against radare2 5.5
  * Closes: #1009173 #1011350

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 29 Aug 2022 11:49:34 +0200

radare2-cutter (1.12.0-1) unstable; urgency=medium

  * New upstream version 1.12.0 (Closes: #976847)
  * d/control: add build dep qttools5-dev

 -- Robert Haist <rha@debian.org>  Mon, 25 Jan 2021 10:18:20 +0100
