=== debian/control ===
--- 
+++ 
@@ -16,6 +16,7 @@
                pkg-config,
                python3-dev,
                qtbase5-dev,
+               qttools5-dev,
                qtwebengine5-dev,
                zlib1g-dev
 Standards-Version: 4.5.0
